Basic templates for DPDK lab deployment with vlan provider network  

This was designed to be deployed with git-stack-lab. See the main README on the main page:  

https://gitlab.cee.redhat.com/akaris/git-stack-lab/blob/master/README.md  

There are a few things to keep in mind:  

1) The basic model is to deploy the undercloud and controllers on a virtualization host and the compute nodes as physical nodes. In step 4 of the master README be sure to use the -P for flag.  For example:  

 ./git-stack-lab/install.sh -r 10GA -P --controller 1 --compute 0 --ceph 0 --owner <yourname> --purpose nfv-deployment  

Notice that controller.yaml has virtual interface names:  
[stack@undercloud-r430 ~]$ grep interface  ./templates-examples/physical/10/dellnfv_dpdkvlan_2.9/nic-configs/controller.yaml -A 1  
              type: interface # physical eth0, provioning network  
              name: nic1  
                  type: interface  
                  name: nic2  
            - type: interface  
              name: nic3  
            - type: interface  
              name: nic4  
  
And that compute.yaml has physical interface names:  
              type: interface # physical eth0, provioning network  
              name: em4  
              type: interface  
              name: p1p1  
            - type: interface  
              name: em1  
                      type: interface  
                      name: p1p2  
            - type: interface  
              name: p2p1  
            - type: interface  
              name: p2p2  

You will want to adjust the interface names in compute.yaml to fit your physical compute hardware.  

2) The instackenv.json will need adjustments to fit your physical hardware also. For physical node examples see https://gitlab.cee.redhat.com/akaris/git-stack-lab/blob/master/instackenv/instackenv-dell-31-34.json.  Before executing Step 5 of the master README you will want to add your physical hardware to the instackenv.json that was created as part of the setup script. Re-import and run another introspection:  
openstack baremetal instackenv validate -f instackenv.json  
openstack overcloud node import instackenv.json   
openstack overcloud node introspect --all-manageable --provide  

[stack@undercloud-r430 ~]$ ./templates-examples/physical/10/dellnfv_dpdkvlan_2.9/deploy.sh 1 2 0  
^That will deploy 1 virtual controller and 2 physical computes  

3) Once the overcloud is deployed this installation differs from the master README. Follow the instructions below.      

curl -o cirros-0.3.5-x86_64-disk.img \  
     http://download.cirros-cloud.net/0.3.5/cirros-0.3.5-x86_64-disk.img  
glance image-create --container-format bare --disk-format qcow2 --name cirros-0.3.5-x86_64-disk --file cirros-0.3.5-x86_64-disk.img  
#to create a cpu pinned, hugepage dpdk instance  
openstack aggregate create --zone=dpdk dpdk  
openstack aggregate set dpdk --property pinned=true  
openstack aggregate add host dpdk overcloud-compute-0.localdomain  
openstack flavor create --ram 1024 --disk 5 --vcpus 1 --property  hw:cpu_policy=dedicated --property hw:cpu_thread_policy=require --property  aggregate_instance_extra_specs:pinned=true --property hw:mem_page_size=1GB cpu-pinned-hugepage-flavor       
openstack network create net1 --provider-physical-network dpdk --provider-network-type vlan --provider-segment 905  
neutron subnet-create --name net1-subnet --enable_dhcp=True --allocation-pool=start=10.0.3.5,end=10.0.3.254 --gateway 10.0.3.1 net1 10.0.3.0/24  
openstack server create --image cirros-0.3.5-x86_64-disk --flavor cpu-pinned-hugepage-flavor --availability-zone dpdk --nic net-id=net1 dpdk_vm1  
^dpdk_vm1 should be ping-able from the undercloud  

4) Verification: See the verification.txt document in this director for a sample of what the deployment should look like for reference. 

